package main

type SimklJWT struct {
	TokenType   string `json:"token_type"`
	AccessToken string `json:"access_token"`
	Scope       string `json:"scope"`
}

type SimklUser struct {
	User struct {
		Name     string `json:"name" ts_type:"name"`
		JoinedAt string `json:"joined_at" ts_type:"joined_at"`
		Gender   string `json:"gender" ts_type:"gender"`
		Avatar   string `json:"avatar" ts_type:"avatar"`
		Bio      string `json:"bio" ts_type:"bio"`
		Loc      string `json:"loc" ts_type:"loc"`
		Age      string `json:"age" ts_type:"age"`
	} `json:"user" ts_type:"user"`
	Account struct {
		Id       int    `json:"id" ts_type:"id"`
		Timezone string `json:"timezone" ts_type:"timezone"`
		Type     string `json:"type" ts_type:"type"`
	} `json:"account" ts_type:"account"`
	Connections struct {
		Facebook bool `json:"facebook" ts_type:"facebook"`
	} `json:"connections" ts_type:"connections"`
}

type SimklWatchList struct {
	Anime []SimklAnime `json:"anime" ts_type:"anime"`
}

type SimklAnime struct {
	LastWatchedAt         string `json:"last_watched_at" ts_type:"last_watched_at"`
	Status                string `json:"status" ts_type:"status"`
	UserRating            int    `json:"user_rating" ts_type:"user_rating"`
	LastWatched           string `json:"last_watched" ts_type:"last_watched"`
	NextToWatch           string `json:"next_to_watch" ts_type:"next_to_watch"`
	WatchedEpisodesCount  int    `json:"watched_episodes_count" ts_type:"watched_episodes_count"`
	TotalEpisodesCount    int    `json:"total_episodes_count" ts_type:"total_episodes_count"`
	NotAiredEpisodesCount int    `json:"not_aired_episodes_count" ts_type:"not_aired_episodes_count"`
	Show                  struct {
		Title  string `json:"title" ts_type:"title"`
		Poster string `json:"poster" ts_type:"poster"`
		Ids    struct {
			Simkl       int    `json:"simkl" ts_type:"simkl"`
			Slug        string `json:"slug" ts_type:"slug"`
			OffJp       string `json:"offjp" ts_type:"offjp"`
			TW          string `json:"tw" ts_type:"tw"`
			ANN         string `json:"ann" ts_type:"ann"`
			Mal         string `json:"mal" ts_type:"mal"`
			Wikien      string `json:"wikien" ts_type:"wikien"`
			WikiJp      string `json:"wikijp" ts_type:"wikijp"`
			AllCin      string `json:"allcin" ts_type:"allcin"`
			IMDB        string `json:"imdb" ts_type:"imdb"`
			TMDB        string `json:"tmdb" ts_type:"tmdb"`
			Offen       string `json:"offen" ts_type:"offen"`
			Crunchyroll string `json:"crunchyroll" ts_type:"crunchyroll"`
			TVDBSlug    string `json:"tvdbslug" ts_type:"tvdbslug"`
			AniList     string `json:"anilist" ts_type:"anilist"`
			AnimePlanet string `json:"animeplanet" ts_type:"animeplanet"`
			AniSearch   string `json:"anisearch" ts_type:"anisearch"`
			Kitsu       string `json:"kitsu" ts_type:"kitsu"`
			LiveChart   string `json:"livechart" ts_type:"livechart"`
			TraktSlug   string `json:"traktslug" ts_type:"traktslug"`
			AniDB       string `json:"anidb" ts_type:"anidb"`
		} `json:"ids" ts_type:"ids"`
	} `json:"show" ts_type:"show"`
	AnimeType string `json:"anime_type" ts_type:"anime_type"`
}

type SimklSyncHistoryType struct {
	Shows []SimklPostShow `json:"shows" ts_type:"shows"`
}

type SimklPostShow struct {
	Title    string `json:"title" ts_type:"title"`
	Ids      `json:"ids" ts_type:"ids"`
	Episodes []Episode `json:"episodes" ts_type:"episodes"`
}

type Episode struct {
	Number int `json:"number" ts_type:"number"`
}

type Ids struct {
	Simkl   int    `json:"simkl" ts_type:"simkl"`
	Mal     string `json:"mal" ts_type:"mal"`
	Anilist string `json:"anilist" ts_type:"anilist"`
}

type ShowWithRating struct {
	Title  string `json:"title" ts_type:"title"`
	Ids    `json:"ids" ts_type:"ids"`
	Rating int `json:"rating" ts_type:"rating"`
}

type ShowWithoutRating struct {
	Title string `json:"title" ts_type:"title"`
	Ids   `json:"ids" ts_type:"ids"`
}

type SimklShowStatus struct {
	Title string `json:"title" ts_type:"title"`
	Ids   `json:"ids" ts_type:"ids"`
	To    string `json:"to" ts_type:"to"`
}

type SimklSearchType []struct {
	Type   string `json:"type"`
	Title  string `json:"title"`
	Poster string `json:"poster"`
	Year   int    `json:"year"`
	Status string `json:"status"`
	Ids    struct {
		Simkl int    `json:"simkl"`
		Slug  string `json:"slug"`
	} `json:"ids"`
	TotalEpisodes int    `json:"total_episodes"`
	AnimeType     string `json:"anime_type"`
}
