export interface AniListCurrentUserWatchList {
    data: {
        Page: {
            pageInfo: {
                total: number
                perPage: number
                currentPage: number
                lastPage: number
                hasNextPage: boolean
            },
            mediaList: MediaList[]
        }
    }
}

export interface AniListGetSingleAnime {
    data: {
        MediaList: MediaList
    }
}

export interface MediaList {
    id: number
    mediaId: number
    userId: number
    media: {
        id: number
        idMal: number
        title: {
            romaji: string
            english?: string
            native: string
        }
        description: string
        coverImage: {
            large: string
        }
        season: string
        seasonYear: number
        status: string
        episodes?: number
        nextAiringEpisode?: {
            airingAt: number
            timeUntilAiring: number
            episode: number
        }
    }
    status: string
    startedAt: {
        year: number
        month: number
        day: number
    }
    completedAt: {
        year?: number
        month?: number
        day?: number
    }
    notes?: string
    progress: number
    score: number
    repeat: number
    user: {
        id: number
        name: string
        avatar: {
            large: string
            medium: string
        }
        statistics: {
            anime: {
                count: number
                statuses: [{
                    status: string
                    count: number
                }]
            }
        }
    }
}