export interface AniSearchList {
    data: {
        Page: {
            pageInfo: {
                total: number,
                currentPage: number,
                lastPage: number,
                hasNextPage: boolean,
                perPage: number
            },
            media: [{
                id: number
                idMal: number
                title: {
                    romaji: string
                    english?: string
                    native: string
                }
                description: string
                coverImage: {
                    large: string
                }
                season: string
                seasonYear: number
                status: string
                episodes?: number
                nextAiringEpisode?: {
                    airingAt: number
                    timeUntilAiring: number
                    episode: number
                }
            }],
        },
    }
}

export interface AniListUser {
    "data": {
        "Viewer": {
            id: number,
            name: string,
            avatar: {
                large: string,
                medium: string,
            },
            bannerImage: string,
            siteUrl: string,
        }
    }
}

export enum MediaListSort {
    MediaId = "MEDIA_ID",
    MediaIdDesc = "MEDIA_ID_DESC",
    Score = "SCORE",
    ScoreDesc = "SCORE_DESC",
    Status = "STATUS",
    StatusDesc = "STATUS_DESC",
    Progress = "PROGRESS",
    ProgressDesc = "PROGRESS_DESC",
    ProgressVolumes = "PROGRESS_VOLUMES",
    ProgressVolumesDesc = "PROGRESS_VOLUMES_DESC",
    Repeat = "REPEAT",
    RepeatDesc = "REPEAT_DESC",
    Priority = "PRIORITY",
    PriorityDesc = "PRIORITY_DESC",
    StartedOn = "STARTED_ON",
    StartedOnDesc = "STARTED_ON_DESC",
    FinishedOn = "FINISHED_ON",
    FinishedOnDesc = "FINISHED_ON_DESC",
    AddedTime = "ADDED_TIME",
    AddedTimeDesc = "ADDED_TIME_DESC",
    UpdatedTime = "UPDATED_TIME",
    UpdatedTimeDesc = "UPDATED_TIME_DESC",
    MediaTitleRomaji = "MEDIA_TITLE_ROMAJI",
    MediaTitleRomajiDesc = "MEDIA_TITLE_ROMAJI_DESC",
    MediaTitleEnglish = "MEDIA_TITLE_ENGLISH",
    MediaTitleEnglishDesc = "MEDIA_TITLE_ENGLISH_DESC",
    MediaTitleNative = "MEDIA_TITLE_NATIVE",
    MediaTitleNativeDesc = "MEDIA_TITLE_NATIVE_DESC",
    MediaPopularity = "MEDIA_POPULARITY",
    MediaPopularityDesc = "MEDIA_POPULARITY_DESC"
}

export interface StartedAt {
    year: number
    month: number
    day: number
}

export interface CompletedAt {
    year: number
    month: number
    day: number
}

export interface AniListUpdateVariables {
    mediaId: number
    progress: number
    status: string
    score: number
    repeat: number
    notes: string
    startedAt: StartedAt
    completedAt: CompletedAt
}