export type SimklUser = {
    user: {
        name: string,
        joined_at: string,
        gender: string,
        avatar: string,
        bio: string,
        loc: string,
        age: string,
    },
    account: {
        id: number,
        timezone: string,
        type: string,
    },
    connections: {
        facebook: boolean
    }
}

export type SimklWatchList = {
    anime: [SimklAnime]
    currentIndex: number
}

export type SimklAnime = {
    last_watched_at: string,
    status: string
    user_rating: number,
    last_watched: string,
    next_to_watch: string,
    watched_episodes_count: number,
    total_episodes_count: number,
    not_aired_episodes_count: number,
    show: {
        title: string,
        poster: string,
        ids: {
            simkl: number,
            slug: string,
            offjp: string,
            tw: string,
            ann: string,
            mal: string,
            wikien: string,
            wikijp: string,
            allcin: string,
            imdb: string,
            offen: string,
            crunchyroll: string,
            tvdbslug: string,
            anilist: string,
            animeplanet: string,
            anisearch: string,
            kitsu: string,
            livechart: string,
            traktslug: string,
            anidb: string,
        }
    },
    anime_type: string
}

export type SimklSearchType = [{
    type: string;
    title: string;
    poster: string;
    year: number;
    status: string;
    ids: {
        simkl: number;
        slug: string;
    };
    totalEpisodes: number;
    animeType: string;
}]